.586 
.model flat, stdcall
option casemap:none
;........................................................................
	include windows.inc
	include user32.inc
	include kernel32.inc
	includelib user32.lib	
	includelib kernel32.lib
;	includelib roak.lib			; not friendly with NT
;	RoakRead PROTO :DWORD, :DWORD, :DWORD
;	includelib first.lib			; friendly with NT
;	PhoneRR PROTO :DWORD, :DWORD, :DWORD	
;........................................................................
.data
; variables for procedure to display number 
	OUT_NUMBER				DD 0
	COUNTER				DD 0
	num_char_written			DD 0
	bytes_to_write			DB 0
;........................................................................
; variables for procedure to input number
	IN_NUMBER				DD 0
	num_char_read			DD 0
	bytes_to_read			DB 0
;........................................................................
; NT variables
	master_msg				DB 10, 13, '     The contents of the master boot sector follow: ', 10, 13, 10, 13
	drive_string			DB '\\.\PHYSICALDRIVE0'
	IoBuffer				DB 512 dup(?)
;........................................................................
; vxd variables
	vxd_name				DB "\\.\roak.vxd", 0
	vxd_title				DB 'Contents of master boot sector from vxd:', 0
	vxd_buf				DB 513 dup(?)
	h_vxd					DD ?
;........................................................................
; dll variables
	ask_msg				DB 10, 13, 10, 13, '     Do you want to get the master sector with three dll''s?', 10, 13, '     Enter 1 if you do: '
	dll_handle				DD 0
	dll_function			DB 'PhoneRR', 0
	PhoneRR_address			DD 0
	dll_name				DB 'first.dll', 0
	dll_buf				DB 513 dup(?)
	dll_title				DB 'Contents of master boot sector from 3 dll''s away:', 0
;........................................................................
; winexec variables
	winexec_title			DB 'z16.exe', 0
	winexec_msg				DB 10, 13, '     Hit enter key to see a 16 bit executible read', 10, 13, '     the master boot sector of physical drive 0.'
;........................................................................
; ME variables
	buffy					DB 512 dup (?)
zds						STRUC
	diStartSector			DD ?		; sector # to start = 0 for boot
	diSectors				DW 1		; number of sectors to read = 1
	diBuffer				DD DWORD PTR buffy
zds						ENDs
	dio 					zds <?>
DEVIOCTL_REGISTERS			STRUC 
	reg_EBX				DD ?
	reg_EDX				DD ? 
	reg_ECX				DD ?                
	reg_EAX				DD ?
	reg_EDI				DD ?
	reg_ESI				DD ?
	reg_Flags				DD ?
DEVIOCTL_REGISTERS			ENDS
	reg					DEVIOCTL_REGISTERS <?> 
	any_msg				DB 10, 13, 10, 13, '     Without a dll or driver you can''t read the', 10, 13, '     master boot sector, but you can read any sector', 10, 13, '     more easily in Windows 98/ME.  Enter a sector number: '
	VXDHandle				DB '\\.\VWIN32', 0
	that_sec_msg			DB 10, 13, '     The contents of sector '
	follow_msg				DB ' follow:', 10, 13, 10, 13
;........................................................................
; general variables
	vxd_warn				DB 'ROAK.VXD HAS CONVERTED NULL CHARACTERS IN THE', 10, 13, 10, 13, 'SECTOR BUFFER TO CHARACTER 32, WHILE DLL HAS NOT!', 10, 13, 10, 13, 'BUT THUNKING OR QT THUNKING IS NOT FRIENDLY WITH NT,',  10, 13, 10, 13, 'SO DLL THUNKING IS NOT USED.  ALSO MESSAGEBOX', 10, 13, 10, 13, 'DISPLAY IS A LITTLE DIFFERENT THAN CONSOLE', 10, 13, 10, 13, 'DISPLAY.  WINEXEC OF 16 BIT PROGRAM NOT USED', 10, 13, 10, 13, 'THOUGH CODED.', 0
	vxd_warn_title			DB 'AN IMPORTANT NOTE FROM RK NOG!', 0
	w_std_handle			DD 0
	r_std_handle			DD 0
	osvl					DB 0
	osvh					DB 0
	returned_byte_count		DD 0
	h_disk				DD 0
	cw_msg				DB 10, 13, 10, 13, "     Freehafer's Windows 95/98/Me/2000/XP Program Is Terminated!", 10, 13, 10, 13, "     (c)2002 INNIEA PUBLISHING COMPANY!  R", 153, 142, "K NOG!", 10, 13, 10, 13, "     Hit enter key to exit . . . "
;........................................................................
.code							; 
start:						; 
;........................................................................
;							; CONVENTIONAL MEMORY
;........................................................................
	invoke GetStdHandle, -11		; 
	mov w_std_handle, EAX			; 
	invoke GetStdHandle, -10		; 
	mov r_std_handle, EAX			; 
;........................................................................
; GET OS VERSION					; 
;........................................................................
	invoke GetVersion				; 
	mov osvl, AL				; 
	mov osvh, AH				; 
	.if osvl == 4 && osvh == 90		; ME
	call vxd_procedure			; 
	.endif					; 
	.if osvl == 4 && osvh == 10		; 98
	call vxd_procedure			; 
	.endif					; 
	.if osvl == 4 && osvh == 0		; 95
	call vxd_procedure			; 
	.endif					; 
	.if osvl == 5				; 2000
	call xp_procedure				; 
	.endif					; 
;........................................................................
; END							; 
	.if osvl != 5
; ONE MORE QUESTION				; 
	invoke MessageBox, 0, ADDR vxd_warn, ADDR vxd_warn_title, 0
	invoke WriteConsole, w_std_handle, ADDR ask_msg, 89, ADDR num_char_written, 0
	call input_number				; 
	.if IN_NUMBER == 1			; 
	call dll_procedure			; frome 3 dll's away is NT friendly
	.endif					; 
	.endif
	invoke WriteConsole, w_std_handle, ADDR cw_msg, 159, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ExitProcess, 0 			; 
;........................................................................
;************************************************************************
;*******************************PROCEDURES*******************************
;************************************************************************
;........................................................................
; procedure to display number			; OUTPUT NUMBER
;........................................................................
output_number proc				; 
	push EAX					; 
	push EBX					; 
	push ECX					; 
	push EDX					; 
	mov EAX, OUT_NUMBER			; number to be displayed
	mov EBX, 10					; 
	mov COUNTER, 0				; recalibrate counter
display_number_loop_next_divide:		; 
	mov EDX, 0					; 
	div EBX					; get next digit in EDX
	push EDX					; store digit 
	inc COUNTER					; 
	cmp EAX, 0					; 
	jne display_number_loop_next_divide	; 
display_number_out_loop:			; 
	pop EDX					; retrieve digit
	add DL, 48					; make a character
	mov bytes_to_write[0], DL		; put character into address
	invoke WriteConsole, w_std_handle, ADDR bytes_to_write, 1, ADDR num_char_written, 0
	dec COUNTER					; 
	.IF (COUNTER > 0)				; 
	jmp display_number_out_loop		; 
	.ENDIF					; 
	pop EDX					; 
	pop ECX					; 
	pop EBX					; 
	pop EAX					; 
	ret						; 
output_number endp				; 
;........................................................................
; procedure to input number			; INPUT NUMBER
;........................................................................
input_number proc					; 
	push EAX					; 
	push EBX					; 
	push ECX					; 
	push EDX					; 
read_loop: 						; 
	mov EBX, 0					; 
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read			; 
	cmp AL, 0            			; special character? are not 0 to 9
	jne not_special        			; if not - process character
	jmp short exit_read          		; finished
not_special:					; 
	cmp al,'0'          			; compare character read to "0" (number?)
	jb exit_read				; if not, don't process
	cmp AL, '9'          			; compare character read to "9" (number?)
	ja exit_read				; if not, don't process 
	sub AL, '0'          			; convert character to number
	mov BL, AL           			; copy character read into BX
	mov EAX, IN_NUMBER			; hex number into AX
	mov ECX, 10					; 
	mul ECX             			; one decimal position to the left
	mov IN_NUMBER, EAX			; store result back into memory
	add IN_NUMBER, EBX			; add current hex digit
	jmp short read_loop     	     	; read next character
exit_read:						; 
	pop EDX					; 
	pop ECX					; 
	pop EBX					; 
	pop EAX					; 
	ret						; 
input_number endp					; 
;........................................................................
; PROCEDURE TO CALL VXD				; 
;........................................................................
vxd_procedure proc				; 
	invoke CreateFile, addr vxd_name, 0, 0, 0, 0, 4000000h, 0
	mov h_vxd, EAX				; 
	invoke DeviceIoControl, h_vxd, 1, 0, 0, ADDR vxd_buf, 512, addr returned_byte_count, 0
	invoke WriteConsole, w_std_handle, ADDR master_msg, 68, ADDR num_char_written, 0
	invoke WriteConsole, w_std_handle, ADDR vxd_buf, 512, ADDR num_char_written, 0
	invoke CloseHandle, h_vxd		; 
	ret						; 
vxd_procedure endp				; 
;........................................................................
; WINEXEC PROCEDURE				; 
;........................................................................
winexec_procedure proc				; 
	invoke GetStdHandle, -10		; read one character at a time
	mov r_std_handle, EAX		; 
	invoke WriteConsole, w_std_handle, ADDR winexec_msg, 102, ADDR num_char_written, 0
	invoke WinExec, ADDR winexec_title, 3	; SW_SHOWMAXIMIZED = 3
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	ret						; 
winexec_procedure endp				; 
;........................................................................
; PROCEDURE READ SECTOR IN 2000/XP		; 
;........................................................................
xp_procedure proc					; 
; GET HANDLE TO DISK TO COPY FROM		; 
	invoke CreateFile, ADDR drive_string, 80000000h or 40000000h, 1 or 2, 0, 3, 0, 0	; OPEN_EXISTING = 3, GENERIC_READ = 0x80000000, GENERIC_WRITE = 0x20000000, FILE_SHARE_READ = 1, FILE_SHARE_WRITE = 2
	mov h_disk, EAX				; 
; LOCK DISK						; 
	invoke DeviceIoControl, h_disk, 589848, 0, 0, 0, 0, ADDR returned_byte_count, 0	; FSCTL_LOCK_VOLUME = 589848
; ALLOCATE						; 
	invoke VirtualAlloc, ADDR IoBuffer, 512, 1000h, 4; PAGE_READWRITE = 4, MEM_COMMIT = 1000h
; READ DISK						; 
	invoke ReadFile, h_disk, ADDR IoBuffer, 512, offset returned_byte_count, 0
; FREE						; 
	invoke VirtualFree, ADDR IoBuffer, 512, 4000h	; MEM_DECOMMIT
; CLOSE HANDLE					; 
	invoke CloseHandle, h_disk		; 
; DISPLAY SECTOR					; 
	invoke WriteConsole, w_std_handle, ADDR master_msg, sizeof master_msg, ADDR num_char_written, 0
	invoke WriteConsole, w_std_handle, ADDR IoBuffer, 512, ADDR num_char_written, 0
	ret						; 
xp_procedure endp					; 
;........................................................................
; PROCEDURE TO GET MASTER BOOT SECTOR WITH THREE DLLS
;........................................................................
dll_procedure proc				; 
;	invoke RoakRead, 80h, ADDR dll_buf, 512
;	invoke PhoneRR, 80h, ADDR dll_buf, 512
	invoke LoadLibrary, ADDR dll_name	; 
	mov dll_handle, EAX			; 
	invoke GetProcAddress, dll_handle, ADDR dll_function
	mov PhoneRR_address, EAX		; 
	push 512					; 
	mov EAX, offset dll_buf			; 
	push EAX					; 
	push 80h					; 
	call [PhoneRR_address]			; 
	jmp no_messagebox				; 
	mov EBX, 0					; null loop
null_loop:						; 
	.if dll_buf[BX] == 0			; 
	mov AL, 32					; 
	mov dll_buf[BX], AL			; 
	.endif					; 
	inc EBX					; 
	.if EBX < 512				; 
	jmp null_loop				; 
	.endif					; 
	mov dll_buf[512], 0			; 
	invoke MessageBox, 0, ADDR dll_buf, ADDR dll_title, 0
no_messagebox:					; 
	invoke WriteConsole, w_std_handle, ADDR dll_buf, 512, ADDR num_char_written, 0
	invoke WriteConsole, w_std_handle, ADDR cw_msg, 159, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ExitProcess, 0			; to avoid push EBX conflict
	ret						; 
dll_procedure endp				; 
;........................................................................
; PROCEDURE TO READ ANY SECTOR IN WINDOWS 98/ME WITH INTERRUPT
;........................................................................
interrupt_procedure proc			; 
; GET SECTOR					; 
	invoke WriteConsole, w_std_handle, ADDR any_msg, 166, ADDR num_char_written, 0
	call input_number				;
	mov EAX, IN_NUMBER			; 
	mov dio.diStartSector, EAX		; 
; GET HANDLE TO DISK TO COPY FROM		; 
	invoke CreateFile, ADDR VXDHandle, 0, 0, 0, 0, 4000000h, 0		; FILE_FLAG_DELETE_ON_CLOSE = 4000000h
	mov h_disk, EAX				; 
; READ SECTOR					; 
	mov reg.reg_ESI, 0h			; read function
	mov reg.reg_EAX, 7305h			; read function
	mov reg.reg_EBX, offset dio		; sector structure
	mov reg.reg_ECX, 0FFFFh			; -1
	mov reg.reg_EDX, 3h			; drive
	invoke DeviceIoControl, h_disk, 6, ADDR reg, SIZE reg, ADDR reg, SIZE reg, offset returned_byte_count, 0	; VWIN32_DIOC_DOS_DRIVEINFO = 6 
; DISPLAY SECTOR					; 
	invoke WriteConsole, w_std_handle, ADDR that_sec_msg, 30, ADDR num_char_written, 0
	mov EAX, dio.diStartSector		; 
	mov OUT_NUMBER, EAX			; 
	call output_number			; 
	invoke WriteConsole, w_std_handle, ADDR follow_msg, 12, ADDR num_char_written, 0
	invoke WriteConsole, w_std_handle, ADDR buffy, 512, ADDR num_char_written, 0	
	ret						; 
interrupt_procedure endp			; 
;........................................................................
end start						; 
